/**
 * STRING_COMPETITION STRING_YEAR - STRING_TRADE - STRING_TITLE
 * Frontend - Task 1
 *
 * This file contains the unit tests performed on the frontend task.
 * You may look at the test cases but not modify them.
 *
 * !!! DO NOT EDIT THIS FILE !!!
 */

describe('Main', () => {
    beforeEach(() => {
        cy.clock()
        cy.visit('/')
        cy.wait(500)
    })

    afterEach(() => {
        cy.wait(500)
    })

    it('can view an initialized timer', () => {
        cy.tick(10000)

        cy.get('#minutes-10 .stroke-horizontal:first-child').should('not.have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-horizontal:nth-child(3)').should('not.have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-horizontal:last-child').should('not.have.class', 'on')

        cy.get('#minutes-1 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-horizontal:nth-child(3)').should('not.have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-horizontal:last-child').should('have.class', 'on')

        cy.get('#seconds-10 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-horizontal:nth-child(3)').should('not.have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-horizontal:last-child').should('have.class', 'on')

        cy.get('#seconds-1 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-horizontal:nth-child(3)').should('not.have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-horizontal:last-child').should('have.class', 'on')
    })

    it('can start a timer', () => {
        cy.get('#start-button').click()

        cy.tick(11000)

        cy.get('#minutes-10 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-horizontal:nth-child(3)').should('not.have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-horizontal:last-child').should('have.class', 'on')

        cy.get('#minutes-1 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-horizontal:nth-child(3)').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-horizontal:last-child').should('have.class', 'on')

        cy.get('#seconds-10 .stroke-horizontal:first-child').should('not.have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-horizontal:nth-child(3)').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-horizontal:last-child').should('not.have.class', 'on')

        cy.get('#seconds-1 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-horizontal:nth-child(3)').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-horizontal:last-child').should('have.class', 'on')
    })

    it('can pause a timer', () => {
        cy.get('#start-button').click()

        cy.tick(11000)

        cy.get('#pause-button').click()

        cy.tick(71000)

        cy.get('#minutes-10 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-horizontal:nth-child(3)').should('not.have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-horizontal:last-child').should('have.class', 'on')

        cy.get('#minutes-1 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-horizontal:nth-child(3)').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-horizontal:last-child').should('have.class', 'on')

        cy.get('#seconds-10 .stroke-horizontal:first-child').should('not.have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-horizontal:nth-child(3)').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-horizontal:last-child').should('not.have.class', 'on')

        cy.get('#seconds-1 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-horizontal:nth-child(3)').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-horizontal:last-child').should('have.class', 'on')
    })

    it('can continue a timer', () => {
        cy.get('#start-button').click()

        cy.tick(7000)

        cy.get('#pause-button').click()

        cy.tick(10000)

        cy.get('#continue-button').click()

        cy.tick(4000)

        cy.get('#minutes-10 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-horizontal:nth-child(3)').should('not.have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-horizontal:last-child').should('have.class', 'on')

        cy.get('#minutes-1 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-horizontal:nth-child(3)').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-horizontal:last-child').should('have.class', 'on')

        cy.get('#seconds-10 .stroke-horizontal:first-child').should('not.have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-horizontal:nth-child(3)').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-horizontal:last-child').should('not.have.class', 'on')

        cy.get('#seconds-1 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-horizontal:nth-child(3)').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-horizontal:last-child').should('have.class', 'on')
    })

    it('can reset a timer', () => {
        cy.get('#start-button').click()

        cy.tick(7000)

        cy.get('#reset-button').click()

        cy.get('#minutes-10 .stroke-horizontal:first-child').should('not.have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-horizontal:nth-child(3)').should('not.have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('not.have.class', 'on')
        cy.get('#minutes-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-10 .stroke-horizontal:last-child').should('not.have.class', 'on')

        cy.get('#minutes-1 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-horizontal:nth-child(3)').should('not.have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#minutes-1 .stroke-horizontal:last-child').should('have.class', 'on')

        cy.get('#seconds-10 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-horizontal:nth-child(3)').should('not.have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-10 .stroke-horizontal:last-child').should('have.class', 'on')

        cy.get('#seconds-1 .stroke-horizontal:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(2) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-horizontal:nth-child(3)').should('not.have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:first-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-vertical-wrapper:nth-child(4) .stroke-vertical:last-child').should('have.class', 'on')
        cy.get('#seconds-1 .stroke-horizontal:last-child').should('have.class', 'on')
    })

    it('can correctly show and hide the buttons', () => {
        cy.get('#start-button').should('not.have.class', 'hidden')
        cy.get('#pause-button').should('have.class', 'hidden')
        cy.get('#continue-button').should('have.class', 'hidden')
        cy.get('#reset-button').should('have.class', 'hidden')

        cy.tick(1000)
        cy.get('#start-button').click()

        cy.get('#start-button').should('have.class', 'hidden')
        cy.get('#pause-button').should('not.have.class', 'hidden')
        cy.get('#continue-button').should('have.class', 'hidden')
        cy.get('#reset-button').should('not.have.class', 'hidden')

        cy.tick(1000)
        cy.get('#pause-button').click()

        cy.get('#start-button').should('have.class', 'hidden')
        cy.get('#pause-button').should('have.class', 'hidden')
        cy.get('#continue-button').should('not.have.class', 'hidden')
        cy.get('#reset-button').should('not.have.class', 'hidden')

        cy.tick(1000)
        cy.get('#continue-button').click()

        cy.get('#start-button').should('have.class', 'hidden')
        cy.get('#pause-button').should('not.have.class', 'hidden')
        cy.get('#continue-button').should('have.class', 'hidden')
        cy.get('#reset-button').should('not.have.class', 'hidden')

        cy.tick(60 * 60 * 1000)

        cy.get('#start-button').should('have.class', 'hidden')
        cy.get('#pause-button').should('have.class', 'hidden')
        cy.get('#continue-button').should('have.class', 'hidden')
        cy.get('#reset-button').should('not.have.class', 'hidden')

        cy.tick(1000)
        cy.get('#reset-button').click()

        cy.get('#start-button').should('not.have.class', 'hidden')
        cy.get('#pause-button').should('have.class', 'hidden')
        cy.get('#continue-button').should('have.class', 'hidden')
        cy.get('#reset-button').should('have.class', 'hidden')
    })
})